package cn.sagacloud.android.cadengine.items

import android.graphics.*
import cn.sagacloud.android.cadengine.types.Column
import cn.sagacloud.android.cadengine.types.Opt
import com.sybotan.android.graphy.SGraphyItem

/**
 * 柱子 Item
 *
 * @author 付国宝
 */
class ColumnItem(private val data: Column, parent: SGraphyItem) : SGraphyItem(parent) {
    /** 画笔 */
    private val paint = Paint()
    /** 墙轮廓 */
    private val pathList = ArrayList<Path>()

    init {
        paint.style = Paint.Style.FILL
        if (data.OutLine != null) {
            for (out in data.OutLine!!) {
                if (out.size < 1) {
                    continue
                }

                val path = Path()
                path.moveTo(out[0].x, out[0].y)
                for (p in out) {
                    path.lineTo(p.x, p.y)
                }
                path.close()
                pathList.add(path)
            }
        }
    } // Init

    /**
     * Item绘制操作
     *
     * @param   canvas          画布
     * @param   rect            绘制区域
     */
    override fun onDraw(canvas : Canvas, rect: RectF){
        paint.color = Opt.columnColor;
        for (path in pathList) {
            canvas.drawPath(path, paint);
        }
    } // Function onDraw()
} // Class ColumnItem