package cn.sagacloud.android.cadengine.items

import android.graphics.Canvas
import android.graphics.Paint
import android.graphics.Path
import android.graphics.RectF
import cn.sagacloud.android.cadengine.types.Opt
import cn.sagacloud.android.cadengine.types.Wall
import com.sybotan.android.graphy.SGraphyItem

/**
 * 墙item
 *
 * @author  郝建龙
 */
class WallItem(private val data: Wall, parent: SGraphyItem) : SGraphyItem(parent) {
    /** 画笔 */
    private val paint = Paint()
    /** 墙轮廓 */
    private val pathList = ArrayList<Path>()

    /**
     * 构造
     */
    init {
        paint.style = Paint.Style.FILL
        if (data.OutLine != null) {
            for (out in data.OutLine!!) {
                if (out.size < 1) {
                    continue
                }

                val path = Path()
                path.moveTo(out[0].x, out[0].y)
                for (p in out) {
                    path.lineTo(p.x, p.y)
                }
                path.close()
                pathList.add(path)
            }
        }
    } // Constructor

    /**
     * Item绘制操作
     *
     * @param   canvas          画布
     * @param   rect            绘制区域
     */
    override fun onDraw(canvas : Canvas, rect: RectF) {
        paint.color = Opt.wallColor;
        for (path in pathList) {
            canvas.drawPath(path, paint);
        }
    } // Function onDraw()
} // Class WallItem